=== modified file 'build.gradle'
--- build.gradle	2022-10-07 10:32:51 +0000
+++ build.gradle	2022-10-27 21:14:39 +0000
@@ -103,6 +103,8 @@
 **     OM  20220812 Upgraded mariadb JDBC driver from 2.7.3 to 3.0.7 GA.
 **     TW  20220928 Changed junixsocket dependency to official repository, and upped its version to latest.
 **     TW  20221007 Upgraded junixsocket to 2.5.2.
+**     VVT 2022xxxx JUnit5 dependencies updated to support both existing tests and custom test engine.
+**                  See #6237.
 */
 
 /*
@@ -582,7 +584,24 @@
        aspectjCompile group: 'org.aspectj', name: 'aspectjweaver', version: aspectjVersion
     }
 
-    fwdAllTest group: 'org.junit.platform', name: 'junit-platform-console-standalone', version: '1.7.1'
+    // Adding JUnit5 jar both to client and server, so it will be also deployed to converted projects
+    fwdClientServer group: 'org.junit.platform',
+                    name: 'junit-platform-engine',
+                    version: '1.9.0'
+
+    fwdClientServer group: 'org.junit.jupiter',
+                    name: 'junit-jupiter-api',
+                    version: '5.9.0'
+
+    fwdClientServer group: 'org.junit.platform',
+                    name: 'junit-platform-suite-engine',
+                    version: '1.9.0'
+    fwdAllTest group: 'org.junit.platform',
+                    name: 'junit-platform-console',
+                    version: '1.9.0'
+    fwdAllTest group: 'org.junit.platform',
+                    name: 'junit-platform-engine',
+                    version: '1.9.0'
 }
 
 // inject ant-optional dependencies to ant, this is needed for the antlr ant target

=== added file 'manifest/org.junit.platform.engine.TestEngine'
--- manifest/org.junit.platform.engine.TestEngine	1970-01-01 00:00:00 +0000
+++ manifest/org.junit.platform.engine.TestEngine	2022-09-19 20:26:43 +0000
@@ -0,0 +1,1 @@
+com.goldencode.p2j.testengine.FWDTestEngine

=== modified file 'rules/annotations/legacy_services.rules'
--- rules/annotations/legacy_services.rules	2022-09-14 15:07:57 +0000
+++ rules/annotations/legacy_services.rules	2022-09-30 11:51:48 +0000
@@ -21,8 +21,7 @@
 ** 005 VVT 20220913 OEUnit support: code removing all annotations removed. See #6237.
 **     VVT 20220913 Prevent unsupported legacy annotations from going to Java code. See #6237.
 **                  Use new create_java_annotation() function to create Java annotation nodes.
-**     VVT 20220914 Changes in revs. 14243,14241,14239 temporarily reverted until JUnit runtime
-**                  support is added to client projects.
+**     VVT 2022xxxx Changes in revs. 14243,14241,14239 restored. See #6237.
 */
  -->
  
@@ -212,9 +211,8 @@
             <while>iter.hasNext()
                <action>prest = iter.next()</action>
                
-               <action>ref = createProgressAst(prog.annotation, "@", pref)</action>
-               <action>ref.putAnnotation("javaname", "LegacyServiceParameter")</action>
-               <action>ref.putAnnotation("name", "LegacyServiceParameter")</action>
+               
+               <action>ref = execLib("create_java_annotation", pref, "LegacyServiceParameter", -1)</action>
                
                <rule>execLib("assign_field_int", ref, "ordinal", prest.ordinal())</rule>
                
@@ -308,7 +306,8 @@
             <rule>keep
                <action>hasSrvs = true</action>
                
-               <action on="false">ref.remove()</action>
+               <!-- Do NOT remove unsupported annotations here, they will be removed in legacy_annotations_post.rules -->
+               <!-- <action on="false">ref.remove()</action> -->
             </rule>
          </while>
       </function>
@@ -343,9 +342,7 @@
          
          <action>hasSrvs = true</action>
          
-         <action>ref = createProgressAst(prog.annotation, "@", copy, 1)</action>
-         <action>ref.putAnnotation("javaname", "LegacyService")</action>
-         <action>ref.putAnnotation("name", "LegacyService")</action>
+         <action>ref = execLib("create_java_annotation", copy, "LegacyService", 1)</action>
          
          <action>execLib("assign_field", ref, "type", "SOAP")</action>
          <action>execLib("assign_field", ref, "namespace", soapOp.getNamespace())</action>
@@ -401,9 +398,7 @@
             <action>soapOp = iter.next()</action>
             <action>hasSrvs = true</action>
 
-            <action>ref = createProgressAst(prog.annotation, "@", copy, 1)</action>
-            <action>ref.putAnnotation("javaname", "LegacyService")</action>
-            <action>ref.putAnnotation("name", "LegacyService")</action>
+            <action>ref = execLib("create_java_annotation", copy, "LegacyService", 1)</action>
             
             <action>execLib("assign_field", ref, "type", "SOAP")</action>
             <action>execLib("assign_field", ref, "namespace", soapOp.getNamespace())</action>
@@ -419,9 +414,7 @@
       <rule>this.type == prog.class_def and srv.isWebHandler(oname)
          <action>hasSrvs = true</action>
          
-         <action>ref = createProgressAst(prog.annotation, "@", copy, 1)</action>
-         <action>ref.putAnnotation("javaname", "LegacyService")</action>
-         <action>ref.putAnnotation("name", "LegacyService")</action>
+         <action>ref = execLib("create_java_annotation", copy, "LegacyService", 1)</action>
          
          <rule>execLib("assign_field", ref, "name", srv.getSection(oname))</rule>
          <rule>execLib("assign_field", ref, "type", "WEBHANDLER")</rule>
@@ -432,9 +425,7 @@
          <while>iter.hasNext()
             <action>path = iter.next()</action>
 
-            <action>ref = createProgressAst(prog.annotation, "@", pref)</action>
-            <action>ref.putAnnotation("javaname", "LegacyWebPath")</action>
-            <action>ref.putAnnotation("name", "LegacyWebPath")</action>
+            <action>ref = execLib("create_java_annotation", pref, "LegacyWebPath", -1)</action>
 
             <action>execLib("assign_field", ref, "path", path.path())</action>
             <action>execLib("assign_field_int", ref, "order", path.order())</action>

=== modified file 'rules/annotations/unit_test_support.rules'
--- rules/annotations/unit_test_support.rules	2022-09-13 16:57:43 +0000
+++ rules/annotations/unit_test_support.rules	2022-10-28 17:54:02 +0000
@@ -9,6 +9,8 @@
 ** _#_ _I_ __Date__  ___________________________Description____________________________
 ** 001 VVT 20220913  Initial version
 **     VVT 20220913  Prevent unsupported legacy annotations from going to Java code. See #6237.
+**     VVT 2022xxxx Custom test engine annotations are now used instead of that
+**                  from the Jupiter test engine. See #6237.
 */
  -->
 <!--
@@ -65,41 +67,231 @@
 -->
 <rule-set>
    <worker class="com.goldencode.p2j.uast.ProgressPatternWorker" namespace="prog" />
+   <worker class="com.goldencode.p2j.uast.UastHintsWorker"       namespace="hints" />
+   <worker class="com.goldencode.p2j.convert.ExpressionConversionWorker" namespace="ecw" />
+   
+   <func-library access="private">
+      <!--
+          Create an assignment <attName>=
+      -->
+      <function name="create_attribute_assignment_right">
+         <!-- The parent node -->
+         <parameter name="parent" type="com.goldencode.ast.Aast" />
+         <!-- the left part attribute name -->
+         <parameter name="attName" type="java.lang.String" />
+         
+         <return name="tref" type="com.goldencode.ast.Aast" />
+         
+         <variable name="chref" type="com.goldencode.ast.Aast" />
+         
+         <rule>tref = createProgressAst(prog.assign, "=", parent)</rule>
+         
+         <rule>chref = createProgressAst(prog.symbol, attName, tref)</rule>
+         <rule>chref.putAnnotation("javaname", attName)</rule>
+      </function>
+   
+      <!--
+          Create an array assignment <attName>=[
+      -->
+      <function name="create_attribute_array_assignment_right">
+         <parameter name="parent" type="com.goldencode.ast.Aast" />
+         <parameter name="attName" type="java.lang.String" />
+         
+         <return name="tref" type="com.goldencode.ast.Aast" />
+         
+         <rule>tref = execLib("create_attribute_assignment_right", parent, attName)</rule>
+         <rule>tref = createProgressAst(prog.lbracket, "[", tref)</rule>
+      </function>
+
+
+      <!--
+          Lookup legacy annotation attribute value
+
+          Input conditions:
+          1. current node is the legacy annotation node
+          2. The attName parameter contains the name of the attribute to lookup
+          
+          Return: attribute value string of null if this annotation has no attribute with the given name.
+      -->
+      <function name="lookup_annotation_attribute_string">
+         <parameter name="attName" type="java.lang.String" />
+         <return name="result" type="java.lang.String" />
+         
+         <rule>result = null</rule>
+         
+         <variable name="attAssignment" type="com.goldencode.ast.Aast" />
+         <!-- Skip the annotation name SYMBOL -->
+         <rule>attAssignment = copy.firstChild.nextSibling</rule>
+         <while>attAssignment != null
+           <!-- Go to the second child, which must be attribute assignment -->
+           <rule>attAssignment.type == prog.assign
+              <action on="false">compileError(367, "Annotation children must be ASSIGNMENTs")</action>
+           </rule>
+           <variable name="attNameNode" type="com.goldencode.ast.Aast" />
+           <action>attNameNode = attAssignment.firstChild</action>
+           <rule>attNameNode.getAnnotation("javaname").equals(attName)
+              <action>result = ecw.stripQuotes(attNameNode.nextSibling.getText())</action>
+              <break/>
+           </rule>
+           <action>attAssignment = attAssignment.nextSibling</action>
+         </while>      
+      </function>
+
+      <function name="create_java_annotation">
+         <parameter name="parent" type="com.goldencode.ast.Aast" />
+         <parameter name="className" type="java.lang.String" />
+         <return name="selectClassesAnno" type="com.goldencode.ast.Aast" />
+         <rule>selectClassesAnno = createProgressAst(prog.annotation, "@", parent)</rule>
+         <rule>selectClassesAnno.putAnnotation("javaname", className)</rule>
+         <!-- ...and mark "our" annotations as preserved -->
+         <rule>selectClassesAnno.putAnnotation("fwd", true)</rule>
+      </function>
+      <!--
+          Process ABLUnit @TestSuite annotation:
+          1. If the suite includes classes, then create a @SelectClasses(value = {Class1.class, Class2...}) annotation
+          2. If the suite includes procedures, then create a @SelectProcedures(value = {"procedure1.p", "procedure2.p"...}) annotation
+          3. Create an empty @Suite annotation
+
+          On entry the current node is the annotation.
+      -->
+      <function name="process_ablunit_test_suite">
+         <!-- Create a marker @Suite annotation-->
+         <rule>execLib("create_java_annotation", copy.parent, "com.goldencode.p2j.testengine.api.Suite")</rule>
+         
+         <!-- Get the "classes" attribute, convert the quoted comma-separated list of class
+              names to nodes of prog.symbol type -->
+         <variable name="classList" type="java.lang.String" />
+         <rule>classList = execLib("lookup_annotation_attribute_string", "classes")</rule>
+         
+         <variable name="lref" type="com.goldencode.ast.Aast" />
+         <rule>classList != null
+            <action>printfln("@TestSuite Classlist %s", classList)</action>
+
+            <!-- Create the @SelectClasses annotation -->
+            <variable name="selectClassesAnno" type="com.goldencode.ast.Aast" />
+            <action>selectClassesAnno = execLib("create_java_annotation", copy.parent, "com.goldencode.p2j.testengine.api.SelectClasses")</action>
+            
+            <!-- Convert comma-separated class name list string into an array of class references -->
+            <!--   Create a node of the array type -->
+            <action>lref = execLib("create_attribute_array_assignment_right", selectClassesAnno, "value")</action>
+            <!-- Parse and convert the comma-separated list -->
+            <variable name="classNameList" type="java.util.List" />
+            <action>classNameList = createListFromObject(classList.split(","))</action>
+            <variable name="classNames" type="java.util.Iterator" />
+            <action>classNames = classNameList.iterator()</action>
+            <while>classNames.hasNext()
+               <variable name="className" type="java.lang.String" />
+               <action>className = (#(java.lang.String)classNames.next()).trim()</action>
+               <action>printfln("Class name '%s'", className)</action>                                       
+               <action>createProgressAst(prog.symbol, sprintf("%s.class", className), lref)</action>
+            </while>
+         </rule>
+
+         <!-- Get the "procedures" attribute, convert the quoted comma-separated list of procedure
+              names to nodes of prog.symbol type -->
+         <variable name="procedureList" type="java.lang.String" />
+         <rule>procedureList = execLib("lookup_annotation_attribute_string", "procedures")</rule>
+         
+         <rule>procedureList != null
+            <action>printfln("@TestSuite procedures %s", procedureList)</action>
+
+            <!-- Create the @SelectProcedures annotation -->
+            <variable name="selectProceduresAnno" type="com.goldencode.ast.Aast" />
+            <action>selectProceduresAnno = execLib("create_java_annotation", copy.parent, "com.goldencode.p2j.testengine.api.SelectProcedures")</action>
+            <!-- Convert comma-separated procedure name list string into an array of procedure name strings -->
+            <!--   Create a node of the array type -->
+            <action>lref = execLib("create_attribute_array_assignment_right", selectProceduresAnno, "value")</action>
+            <!-- Parse and convert the comma-separated list -->
+            <variable name="procedureNameList" type="java.util.List" />
+            <action>procedureNameList = createListFromObject(procedureList.split(","))</action>
+            <variable name="procedureNames" type="java.util.Iterator" />
+            <action>procedureNames = procedureNameList.iterator()</action>
+            <while>procedureNames.hasNext()
+               <variable name="procedureName" type="java.lang.String" />
+               <action>procedureName = (#(java.lang.String)procedureNames.next()).trim()</action>
+               <action>printfln("Procedure name '%s'", procedureName)</action>                                       
+               <action>createProgressAst(prog.string, sprintf("'%s'", procedureName), lref)</action>
+            </while>
+         </rule>
+         <!-- Drop the original value -->
+         <rule>copy.remove()</rule>
+      </function>
+   </func-library>
+
    <walk-rules>
       <rule>this.type == prog.annotation
-            and parent.type == prog.method_def
+            and (parent.type == prog.method_def
+                 or parent.type == prog.procedure
+                 or parent.type == prog.class_def)
+            
+         <!-- Get required unit test legacy type configuration (hints) -->
+         <variable name="unitTestType" type="java.lang.String" />
+         <action>unitTestType = hints.getUnitTestType()</action>
+         <rule>unitTestType == null
+            <action>compileError(223, "No unit test legacy type is configured")</action>
+         </rule>
+         
+         <variable name="isABLUnit" type="java.lang.Boolean" />
+         <action>isABLUnit = unitTestType.equals("ABLUnit")</action>
+
+         <variable name="methodNode" type="com.goldencode.ast.Aast" />
+         <action>methodNode = parent.firstChild</action>
+
+         <!-- FIXME: Add similar support for procedures -->
 
          <!-- Get initial annotation name -->
          <variable name="annoName" type="java.lang.String" />
          <action>annoName = this.getAnnotation("javaname")</action>
 
+         <action>printfln("method %s is ABL unit test type %s annoName @%s", methodNode.getAnnotation("name"), isABLUnit, annoName)</action>
+
          <variable name="newName" type="java.lang.String" />
          <action>newName = null</action>
 
-         <!-- Replace OEUnit annotation names (made after JUnit 4) by JUnit 5 names -->
-         <rule>annoName.equals("Test")
-            <action>newName = "org.junit.jupiter.api.Test"</action>
-            <rule on="false">annoName.equals("Before")
-               <action>newName = "org.junit.jupiter.api.BeforeEach"</action>
-               <rule on="false">annoName.equals("After")
-                  <action>newName = "org.junit.jupiter.api.AfterEach"</action>
-                  <rule on="false">annoName.equals("BeforeClass")
-                     <action>newName = "org.junit.jupiter.api.BeforeAll"</action>
-                     <rule on="false">annoName.equals("AfterClass")
-                        <action>newName = "org.junit.jupiter.api.AfterAll"</action>
-                        <rule on="false">annoName.equals("Ignore")
-                           <action>newName = "org.junit.jupiter.api.Disabled"</action>
+         <!-- Replace OEUnit/ABLUnit annotation names by corresponding JUnit5 names -->
+         <rule>annoName.equalsIgnoreCase("Test")
+            <action>newName = "com.goldencode.p2j.testengine.api.Test"</action>
+
+            <!-- Note: the meaning of @Before and @After is opposite in ABLUnit and OEUnit -->
+            <rule on="false">annoName.equalsIgnoreCase("Before")
+               <rule>isABLUnit
+                  <action>newName = "com.goldencode.p2j.testengine.api.BeforeAll"</action>
+                  <action on="false">newName = "com.goldencode.p2j.testengine.api.BeforeEach"</action>
+               </rule>
+               <rule on="false">annoName.equalsIgnoreCase("After")
+                  <rule>isABLUnit
+                     <action>newName = "com.goldencode.p2j.testengine.api.AfterAll"</action>
+                     <action on="false">newName = "com.goldencode.p2j.testengine.api.AfterEach"</action>
+                  </rule>
+                  <rule on="false">annoName.equalsIgnoreCase("BeforeClass")
+                     <action>newName = "com.goldencode.p2j.testengine.api.BeforeAll"</action>
+                     <rule on="false">annoName.equalsIgnoreCase("AfterClass")
+                        <action>newName = "com.goldencode.p2j.testengine.api.AfterAll"</action>
+                        <rule on="false">annoName.equalsIgnoreCase("Ignore")
+                           <action>newName = "com.goldencode.p2j.testengine.api.Disabled"</action>
+                           <rule on="false">annoName.equalsIgnoreCase("Setup")
+                              <action>newName = "com.goldencode.p2j.testengine.api.BeforeEach"</action>
+                              <rule on="false">annoName.equalsIgnoreCase("TearDown")
+                                 <action>newName = "com.goldencode.p2j.testengine.api.AfterEach"</action>
+   
+                                 <!-- ABLUnit @TestSuite(classes="classname1,classname2...", procedures="procedure1.p,procedure2.p...") -->
+                                 <rule on="false">annoName.equalsIgnoreCase("TestSuite")
+                                    <action>execLib("process_ablunit_test_suite")</action>
+                                 </rule>
+                              </rule>
+                           </rule>
                         </rule>
                      </rule>
                   </rule>
                </rule>
             </rule>
          </rule>
-
          <rule>newName != null
-           <!-- Write it back and mark "our" annotations as preserved -->
-           <action>copy.putAnnotation("javaname", newName)</action>
-           <action>copy.putAnnotation("fwd", true)</action>
+            <action>printfln("newName %s", newName)</action>
+            <!-- Write it back... -->
+            <action>copy.putAnnotation("javaname", newName)</action>
+            <!-- ...and mark "our" annotations as preserved -->
+            <action>copy.putAnnotation("fwd", true)</action>
          </rule>
       </rule>
       

=== modified file 'rules/convert/unit_test_support.rules'
--- rules/convert/unit_test_support.rules	2022-09-13 16:57:43 +0000
+++ rules/convert/unit_test_support.rules	2022-10-18 18:36:43 +0000
@@ -9,6 +9,8 @@
 ** _#_ _I_ __Date__  ___________________________Description____________________________
 ** 001 VVT 20220913  Initial version
 **     VVT 20220913  Prevent unsupported legacy annotations from going to Java code. See #6237.
+**     VVT 2022xxxx  Custom test engine annotations are now used instead of that
+**                   from the Jupiter test engine. See #6237.
 */
  -->
 <!--
@@ -66,30 +68,32 @@
 <rule-set>
    <worker class="com.goldencode.p2j.convert.ConverterHelper" namespace="help" />
    <worker class="com.goldencode.p2j.uast.ProgressPatternWorker" namespace="prog" />
+   <worker class="com.goldencode.p2j.convert.ExpressionConversionWorker" namespace="ecw" />
+   
    <variable name="hasJUnit5Annotations" type="java.lang.Boolean"/>
 
    <!-- Detect if any of JUnit 5 annotations exist in the tree -->
    <walk-rules>
       <rule>this.type == prog.annotation
-            and parent.type == prog.method_def
+            and (parent.type == prog.method_def or parent.type == prog.class_def)
          <variable name="annoName" type="java.lang.String" />
          <action>annoName = this.getAnnotation("javaname")</action>
          <rule>
-            annoName.equals("org.junit.jupiter.api.Test") or
-            annoName.equals("org.junit.jupiter.api.BeforeEach") or
-            annoName.equals("org.junit.jupiter.api.AfterEach")  or
-            annoName.equals("org.junit.jupiter.api.BeforeAll")  or
-            annoName.equals("org.junit.jupiter.api.AfterAll")   or
-            annoName.equals("org.junit.jupiter.api.Disabled")
+            annoName.startsWith("com.goldencode.p2j.testengine.api.")
             <!-- Replace fully-qualified name by simple name -->
-            <action>copy.putAnnotation("javaname", annoName.substring(22))</action>
+            <action>copy.putAnnotation("javaname", annoName.substring(34))</action>
             <action>hasJUnit5Annotations = true</action>
          </rule>
       </rule>
+      <rule>upPath("ANNOTATION/ASSIGN/LBRACKET")
+            and this.type == prog.symbol
+         <action>printfln("ANNOTATION/ASSIGN/LBRACKET text '%s'", this.getText())</action>
+         <action>createJavaAst(java.reference, ecw.stripQuotes(this.getText()), getClosestPeerId())</action>
+      </rule>
    </walk-rules>
    <post-rules>
       <rule>hasJUnit5Annotations == true
-         <action>help.createImport("org.junit.jupiter.api.*")</action>
+         <action>help.createImport("com.goldencode.p2j.testengine.api.*")</action>
          <action>hasJUnit5Annotations = false</action>
       </rule>
    </post-rules>

=== modified file 'src/com/goldencode/p2j/cfg/Configuration.java'
--- src/com/goldencode/p2j/cfg/Configuration.java	2022-04-22 22:17:35 +0000
+++ src/com/goldencode/p2j/cfg/Configuration.java	2022-09-30 11:47:48 +0000
@@ -75,6 +75,7 @@
 **     CA  20220412          Added file-set support (either -Z command-line option or p2j.cfg.xml 
 **                           configuration).
 **     OM  20220421          Restored the ability to load the configuration file relative to P2J_HOME folder.
+**     VVT 2022xxxx          Constant added: default legacy unit test framework type. See #6237. 
 */
 
 /*
@@ -268,6 +269,9 @@
    /** Default configuration filename */
    public static final String DEF_CFG_FILE = "p2j.cfg.xml";
    
+   /** Default legacy unit test type */
+   public static final String DEF_UNIT_TEST_TYPE = "ABLUnit";
+   
    /** Singleton instance. */
    private static volatile Configuration instance;
    

=== modified file 'src/com/goldencode/p2j/main/ClientCore.java'
--- src/com/goldencode/p2j/main/ClientCore.java	2022-09-18 16:13:54 +0000
+++ src/com/goldencode/p2j/main/ClientCore.java	2022-10-12 22:01:49 +0000
@@ -60,6 +60,8 @@
 **     CA  20220208 Added -errorstack command-line option (client:cmd-line-option:error-stack).
 **     SVL 20220620 "ininame" parameter handling moved earlier to TC.initializePost.
 **     CA  20220918 Added socket trust store filename and password to the ClientParameters.
+**     VVT 2022xxxx Native methods processInit and getPid made public to be accessible from
+**                  FWD test engine. See #6237.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -121,12 +123,13 @@
 import java.util.logging.*;
 
 import com.goldencode.p2j.cfg.*;
+import com.goldencode.p2j.directory.*;
 import com.goldencode.p2j.net.*;
-import com.goldencode.p2j.directory.*;
+import com.goldencode.p2j.net.Session;
 import com.goldencode.p2j.security.SecurityManager;
+import com.goldencode.p2j.ui.chui.*;
 import com.goldencode.p2j.ui.client.*;
 import com.goldencode.p2j.ui.client.driver.*;
-import com.goldencode.p2j.ui.chui.ThinClient;
 import com.goldencode.p2j.util.*;
 
 /**
@@ -172,7 +175,6 @@
     *           <code>false</code> for the normal client JVM startup.
     * @param    diag
     *           Details about the driver state that can help diagnose server startup issues.
-    *           
     * @throws Exception 
     */
    public static void start(BootstrapConfig config, boolean file, boolean single, Supplier<String> diag)
@@ -357,6 +359,7 @@
          // set up current user name for client session
          ThinClient.getInstance().setUserName(params.osUserName);
 
+         
          // call the application
          running = main.standardEntry();
          
@@ -438,17 +441,21 @@
    /**
     * Native call to set up and redefine signal processing handlers.
     */
-   private static native void processInit();
+   public static native void processInit();
    
    /**
     * Native call to read the operating system pid for the current JVM process.
+    * 
+    * @return see above 
     */
-   private static native long getPid();
+   public static native long getPid();
    
    /**
     * Native call to read the operating system user name for the current JVM process.
+    * 
+    * @return see above 
     */
-   private static native String getUserName();
+   public static native String getUserName();
    
    /**
     * Initialize the logger if needed.

=== modified file 'src/com/goldencode/p2j/main/StandardServer.java'
--- src/com/goldencode/p2j/main/StandardServer.java	2022-10-05 08:54:36 +0000
+++ src/com/goldencode/p2j/main/StandardServer.java	2022-10-12 21:57:10 +0000
@@ -203,6 +203,7 @@
 **                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
 **                           processing all the scopeables for each and every block.
 **     CA  20220906          Moved the interactive client cleaner to LogicalTerminal.registerCleaner().
+**     VVT 2022xxxx          UnitTestEngine static network server registration added. See #6237.
 */
 
 /*
@@ -264,12 +265,15 @@
 import java.lang.reflect.*;
 import java.util.*;
 import java.util.concurrent.*;
-import java.util.function.Supplier;
+import java.util.function.*;
 import java.util.logging.*;
+
 import javax.servlet.*;
+
 import org.eclipse.jetty.server.handler.*;
 import org.eclipse.jetty.util.resource.Resource;
 import org.eclipse.jetty.webapp.*;
+
 import com.goldencode.ast.*;
 import com.goldencode.p2j.*;
 import com.goldencode.p2j.admin.*;
@@ -287,6 +291,7 @@
 import com.goldencode.p2j.security.*;
 import com.goldencode.p2j.security.SecurityManager;
 import com.goldencode.p2j.soap.*;
+import com.goldencode.p2j.testengine.*;
 import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.util.*;
 import com.goldencode.p2j.util.ErrorManager;
@@ -992,7 +997,9 @@
       
       ifaces = new Class[] { ServerPropertiesInspector.class };
       RemoteObject.registerStaticNetworkServer(ifaces, ServerPropertiesDaemon.class);
-      
+            
+      RemoteObject.registerStaticNetworkServer(new Class[] { UnitTestEngine.class }, UnitTestServer.class);
+
       AdminServerImpl.initialize();
       
       DirectoryManager.initServer();
@@ -1114,7 +1121,7 @@
     * @param   ds
     *          The directory service.
     */
-   private void initClassLoaders(DirectoryService ds)
+   private static void initClassLoaders(DirectoryService ds)
    {
       // initialize the class loaders for the jars defined in the directory
       String path = Utils.findDirectoryNodePath(ds,

